<?php

class pbCollectionCreateProcessor extends modObjectCreateProcessor
{
    public $objectType = 'pb_object';
    public $classKey = pbCollection::class;
    public $languageTopics = ['pageblocks'];


    /**
     * @return bool
     */
    public function beforeSet()
    {
        $name = trim($this->properties['name']);
        if (empty($name)) {
            $this->modx->error->addField('name', $this->modx->lexicon($this->objectType.'_err_name'));
        } elseif ($this->modx->getCount($this->classKey, [
            'name' => $name
        ])) {
            $this->modx->error->addField('name', $this->modx->lexicon($this->objectType.'_err_ae'));
        }

        if (isset($this->properties['ab_templates'])) {
            $this->properties['ab_templates'] = implode('||', $this->properties['ab_templates']);
        }

        $this->properties['menuindex'] = $this->modx->getCount($this->classKey)+1;

        return true;
    }

}

return 'pbCollectionCreateProcessor';