<?php

class pbCollectionUpdateProcessor extends modObjectUpdateProcessor
{
    public $objectType = 'pb_object';
    public $classKey = pbCollection::class;
    public $languageTopics = ['pageblocks'];


    /**
     * @return bool
     */
    public function beforeSet()
    {
        $id = (int) $this->properties['id'];
        if (empty($id)) {
            return $this->modx->lexicon('pb_object_err_ns');
        }

        $name = trim($this->properties['name']);
        if (empty($name)) {
            $this->modx->error->addField('name', $this->modx->lexicon($this->objectType.'_err_name'));
        } elseif ($this->modx->getCount($this->classKey, [
            'id:!=' => $id,
            'name' => $name,
        ])) {
            $this->modx->error->addField('name', $this->modx->lexicon($this->objectType.'_err_ae'));
        }

        if (isset($this->properties['ab_templates'])) {
            $this->properties['ab_templates'] = implode('||', $this->properties['ab_templates']);
        }

        return true;
    }
}

return 'pbCollectionUpdateProcessor';